function Bunker:makelombie()
self.czlist = {"Light", "Regular", "Heavy", "Regen", "Regen", "Regular", "Light", "Light"}
self.zombieweaponlist = {"Auto Pistol", "Heavy Pistol", "Pistol","Blunderpop", "Blunderbuss","Zombie Shotgun", "Zombie SMG"}
self.zombiebomblist = {"Stone", "Stick Grenade"}
local zombie1 = CreateAHuman(self.czlist[math.random(#self.czlist)].." Cyborg Zombie")
zombie1:AddInventoryItem(CreateHDFirearm(self.zombieweaponlist[math.random(#self.zombieweaponlist)]))
zombie1:AddInventoryItem(CreateTDExplosive(self.zombiebomblist[math.random(#self.zombiebomblist)]))
zombie1.Team = globalczteam
zombie1.AIMode = Actor.AIMODE_GOTO;
return zombie1
end

function Bunker:teleporteffect(pos)
   if math.random(2) == 1 then
  	 local fxa = CreateAEmitter("Teleporter Effect A");
  	 fxa.Pos = pos;
  	 MovableMan:AddParticle(fxa);
   else
 	  local fxb = CreateAEmitter("Teleporter Effect B");
 	  fxb.Pos = pos;
 	  MovableMan:AddParticle(fxb);
   end
end

function Bunker:getsafelocation()
local v = Vector(math.random(200,SceneMan.SceneDim.X - 200), math.random(200,SceneMan.SceneDim.Y - 200))
while SceneMan:GetTerrMatter(v.X,v.Y) ~= 0 or SceneMan:GetMOIDPixel(v.X,v.Y) ~= 255 do
v = Vector(math.random(200,SceneMan.SceneDim.X - 200), math.random(200,SceneMan.SceneDim.Y - 200))
end
v.Y = SceneMan:MovePointToGround(v,0,0).Y - 12
return v
end
function Bunker:StartActivity()

	self.ExitZone = SceneMan.Scene:GetArea("Escape Zone")
	self.GiftGuns = {"Zombie SMG", "Blunderpop", "Blunderbuss", "Zombie Shotgun", "Heavy Pistol", "Pistol"}
	self.GiftBombs = {"Stone", "Grenade", "Cluster Grenade", "Distractor Device", "Blue Bomb", "Incendiary Grenade", "Explosive Charge"}
	self.GunProb = 4
	self.braindead = {};
	self.AssignedBrains = {};
	self.maxmoids = 110 -- Reduce this if you have a slow computer, or if you are a coward.
	self.ztime = (2500 * ((100-self.Difficulty)/100)) + 500
	self.prizetime = 8000
	self.PrizeTimer = Timer()
	self.ztime = self.ztime / self.PlayerCount
	self.maxmoids = self.maxmoids + (120 * (self.Difficulty/100))
	self.brainhurt = ((100-self.Difficulty) + 50) * 250
	self.brainhurt = self.brainhurt / self.PlayerCount
	if self.Difficulty < 50 or self.PlayerCount > 1 then
		globalczteam = 1
	else
		globalczteam = -1
	end
	self.bdeath = self:GetTeamDeathCount(globalczteam)
    
    self.SpawnTimer = Timer();
	self.FoWTimer = Timer();
    local weapon = nil
	local brain = nil
	local clone = nil
   	for player = 0, self.PlayerCount - 1 do
		if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			weapon = CreateHDFirearm("Auto Pistol","Coalition.rte")
			clone = CreateAHuman("Uberscout","CyborgZombies.rte");
			brain = CreateAHuman("RPG Bot 9000","CyborgZombies.rte");
			weapon2 = CreateHDFirearm("Heavy Pistol","Coalition.rte")
			brain.Team = 0;
			brain.AIMode = Actor.AIMODE_SENTRY;
			clone.Team = 0
			clone.AIMode = Actor.AIMODE_SENTRY
			brain.Pos = Vector(1760 - 50 * (player + 1), 4083);
			clone.Pos = Vector(1800 - 25 * (player + 1), 3988); --1754
			clone:AddInventoryItem(weapon)
			brain:AddInventoryItem(weapon2)
			MovableMan:AddActor(clone);
			MovableMan:AddActor(brain);
			foundBrain = brain;
			self.AssignedBrains[player] = brain;
			self:SetPlayerBrain(brain, player);
			--self:SetViewState(Activity.ACTORSELECT, player); --nice but distracting in this case.
			--self:SetActorSelectCursor(brain.Pos, player);
			self:SetObservationTarget(brain.Pos, player)
			self:SwitchToActor(clone,player,0)
		end
	end
	SceneMan:MakeAllUnseen(Vector(5, 5), Activity.TEAM_1)
    for actor in MovableMan.AddedActors do
		if actor.ClassName ~= "ADoor" then
			actor.AIMode = Actor.AIMODE_SENTRY;
		else
			actor.Team = globalczteam
		end
    end
	
end
function Bunker:PauseActivity(pause)
    print("PAUSE! -- DummyAssault:PauseActivity()!");
end
function Bunker:EndActivity()
    print("END! -- DummyAssault:EndActivity()!");
end
function Bunker:UpdateActivity()
	self:SetTeamFunds(0 , 0); --comment out this, i dare you
   	--self:ClearObjectivePoints();
   	self:DoBrainSelection();
	if self.FoWTimer:IsPastSimMS(self.brainhurt) then
		self.FoWTimer:Reset()
		SceneMan:MakeAllUnseen(Vector(5, 5), Activity.TEAM_1)
		for player = 0, self.PlayerCount - 1 do
			local actor = self:GetControlledActor(player)
			if MovableMan:IsActor(actor) then
				self:teleporteffect(actor.Pos)
				actor:FlashWhite(2500)
			end
		end
	end
	if self.SpawnTimer:IsPastSimMS(self.ztime) and MovableMan:GetMOIDCount() <= self.maxmoids then
		self:SpawnZombies();
		self.SpawnTimer:Reset()
	end
	if self.PrizeTimer:IsPastSimMS(self.prizetime) and MovableMan:GetMOIDCount() <= 245 then
		self.PrizeTimer:Reset()
		if math.random(self.GunProb) == 1 then
			local gun = CreateHDFirearm(self.GiftGuns[math.random(#self.GiftGuns)])
			gun.Pos = self:getsafelocation()
			self:teleporteffect(gun.Pos)
			MovableMan:AddItem(gun)
		else
			local bomb = CreateTDExplosive(self.GiftBombs[math.random(#self.GiftBombs)])
			bomb.Pos = self:getsafelocation()
			self:teleporteffect(bomb.Pos)
			MovableMan:AddItem(bomb)
		end
		local deduction = (self:GetTeamDeathCount(globalczteam) - self.bdeath) * ((150-self.Difficulty)/100)
		if deduction > 15 then
			deduction = 15
		end
		self.prizetimer = (8000 - (deduction * 500))
		
	end
	for player = 0, self.PlayerCount - 1 do
		local actor = self:GetControlledActor(player)
		if MovableMan:IsActor(actor) and actor.AIMode == Actor.AIMODE_GOTO then
			actor.Health = -100
		end
	end
	--self:YSortObjectivePoints();
end
function Bunker:SpawnZombies()
	local zombie = self:makelombie()
	zombie.Pos = self:getsafelocation()
	if math.random(math.ceil((120-self.Difficulty)/10)) <= self.PlayerCount then
		zombie:AddAIMOWaypoint(self:GetControlledActor(math.random(0,self.PlayerCount)))
	else
		zombie.AIMode = Actor.AIMODE_SENTRY
	end
	zombie:FlashWhite(2500)
	self:teleporteffect(zombie.Pos)
	--zombie.Health = 0
	MovableMan:AddActor(zombie)
end
function Bunker:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self.AssignedBrains[player] = newBrain;
					self:SwitchToActor(newBrain, player, team);
				else
					FrameMan:SetScreenText("Commander died!", player, 333, -1, false);
					self.braindead[player] = true;
					if not MovableMan:GetClosestBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team);
						ActivityMan:EndActivity();
					end
				end
			else
				self:SetObservationTarget(brain.Pos, player)
					
				if self.ExitZone:IsInside(brain.Pos) then
					FrameMan:SetScreenText("You escaped!", player, 333, -1, false);
					self.WinnerTeam = 0
					ActivityMan:EndActivity();
				end
			end -- 
		end --for
	end
end
