function GreyGooDefense:StartActivity()
self.FightStage = { ATTACK = 0, RUN = 1}
self.evacarea = SceneMan.Scene:GetArea("Evacuate Area");
self.RescueLZ = SceneMan.Scene:GetArea("Landing Pad");
self.movarea = SceneMan.Scene:GetArea("Keep Movin");
self.maxmoids = 115 -- Reduce this if you have a slow computer, or if you are a coward.
self.ztime = (2500 * ((100-self.Difficulty)/100)) + 500
self.maxmoids = self.maxmoids + (120 * (self.Difficulty/100))
self:SetTeamFunds(5000 * ((100-self.Difficulty) / 100), Activity.TEAM_1);
if self.Difficulty < 50 then
    globalczteam = 1
else
    globalczteam = -1
end
--[[
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.ztime = 3000
		self:SetTeamFunds(10000, Activity.TEAM_1);
        globalczteam = 1
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.ztime = 2500
        globalczteam = 1
		self:SetTeamFunds(8000, Activity.TEAM_1);
        self.maxmoids = self.maxmoids + 24
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.ztime = 2000
        globalczteam = 1
		self:SetTeamFunds(6000, Activity.TEAM_1);
        self.maxmoids = self.maxmoids + 48
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.ztime = 1500
        globalczteam = -1
		self:SetTeamFunds(4000, Activity.TEAM_1);
        self.maxmoids = self.maxmoids + 72
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.ztime = 1000
        globalczteam = -1
		self:SetTeamFunds(2000, Activity.TEAM_1);
        self.maxmoids = self.maxmoids + 96
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then --2x zed cap, 6x spawn time compared to cake :)
		self.ztime = 500
		self:SetTeamFunds(0, Activity.TEAM_1);
        globalczteam = -1
        self.maxmoids = self.maxmoids + 120
	end
    --]]
self.ztimer = Timer()
self.playerbrain = CreateAHuman("Braincoat Heavy")
self.playerbrain.Team = 0
self.playerbrain.Pos = Vector(3936,1160)
MovableMan:AddActor(self.playerbrain)
for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
    self:SetPlayerBrain(self.playerbrain, player)
end

--self:SetPlayerBrain(self.playerbrain, 0)
self:SetLandingZone(self.RescueLZ:GetCenterPoint(),0)
self.playerbrain.AIMode = Actor.AIMODE_SENTRY;
self.RoundTimer = Timer();
--self.ActivityState = Activity.EDITING --Hehe. No.
self.hy = SceneMan:FindAltitude(Vector(0,0),0,0)
self.CurrentFightStage = 0
for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
   self:SetObservationTarget(self.playerbrain.Pos, player)
end

self.stopworking = false
self.braindead = false
end

function GreyGooDefense:makeczombie()
self.czlist = {"Light", "Regular", "Heavy", "Regen"}
self.zombieweaponlist = {"Zombie SMG", "Blunderpop", "Blunderbuss", "Zombie Shotgun", "Heavy Pistol"}
self.zombiebomblist = {"Blue Bomb", "Stone", "Stick Grenade", "Blue Bomb"}
local zombie1 = CreateAHuman(self.czlist[math.random(#self.czlist)].." Replicating Zombie")
zombie1:AddInventoryItem(CreateHDFirearm(self.zombieweaponlist[math.random(#self.zombieweaponlist)]))
zombie1:AddInventoryItem(CreateHDFirearm("Zombie Shovel"))
zombie1:AddInventoryItem(CreateTDExplosive(self.zombiebomblist[math.random(#self.zombiebomblist)]))
zombie1.Team = globalczteam
zombie1.AIMode = Actor.AIMODE_GOTO;
return zombie1
end

function GreyGooDefense:EndActivity()
end
function GreyGooDefense:teleporteffect(pos)
   if math.random(2) == 1 then
  	 local fxa = CreateAEmitter("Teleporter Effect A");
  	 fxa.Pos = pos;
  	 MovableMan:AddParticle(fxa);
   else
 	  local fxb = CreateAEmitter("Teleporter Effect B");
 	  fxb.Pos = pos;
 	  MovableMan:AddParticle(fxb);
   end
end
function GreyGooDefense:UpdateActivity()
--self.CurrentFightStage = baxbox
self:ClearObjectivePoints();
if self.braindead then
    self.braindead = false
    local yep = true
    for a in MovableMan.Actors do
        if a:HasObjectInGroup("Brains") then
            yep = false
        end
    end
    if yep then
        self.WinnerTeam = globalczteam
        self.stopworking = true
        for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
            FrameMan:ClearScreenText(player)
            FrameMan:SetScreenText("Your brain has been destroyed!", player, 0, 9999999, false);
        end
    ActivityMan:EndActivity()
            for ab in MovableMan.Actors do
                if ab.Team == 0 and ab.ClassName ~= "ADoor" then
                    ab.Health = 8
                    table.insert(cyborgzombielist,ab)
                end
            end
    end
end
if self.ActivityState ~= Activity.EDITING and not(self.stopworking or FrameMan:IsResettingRTE()) then
    if MovableMan:IsActor(self.playerbrain) then
        if not self.playerbrain:HasObjectInGroup("Brains") then
            self.playerbrain = nil
        elseif self.CurrentFightStage ~= self.FightStage.RUN then
            self.playerbrain.Vel = Vector(0,0);
            self.playerbrain.Pos = Vector(3936,1160)
            self.playerbrain.AngularVel = 0;
            self.playerbrain.RotAngle = 0;
            self:AddObjectivePoint("Protect!", self.playerbrain.AboveHUDPos, Activity.TEAM_1, GameActivity.ARROWDOWN);
            if (self.playerbrain.Pos.Y < 0 and self.playerbrain.Vel.Y < 0) or (self.playerbrain.Pos.Y > SceneMan.SceneDim.Y and self.playerbrain.Vel.Y > 0) or (self.playerbrain.Pos.X < 0 and self.playerbrain.Vel.X < 0) or (self.playerbrain.Pos.X > SceneMan.SceneDim.X and self.playerbrain.Vel.X > 0) then
                self.playerbrain.Vel = Vector(-self.playerbrain.Vel.X,-self.playerbrain.Vel.Y)
            end
        else
            if self.playerbrain.ClassName == "ACDropShip" or self.playerbrain.ClassName == "ACRocket" then
                self:AddObjectivePoint("Get into orbit!", self.playerbrain.AboveHUDPos , Activity.TEAM_1, GameActivity.ARROWDOWN);
            else
                self:AddObjectivePoint("Evacuate!", self.playerbrain.AboveHUDPos, Activity.TEAM_1, GameActivity.ARROWDOWN);
                if (self.playerbrain.Pos.Y < 0 and self.playerbrain.Vel.Y < 0) or (self.playerbrain.Pos.Y > SceneMan.SceneDim.Y and self.playerbrain.Vel.Y > 0) or (self.playerbrain.Pos.X < 0 and self.playerbrain.Vel.X < 0) or (self.playerbrain.Pos.X > SceneMan.SceneDim.X and self.playerbrain.Vel.X > 0) then
                    self.playerbrain.Vel = Vector(-self.playerbrain.Vel.X,-self.playerbrain.Vel.Y)
                end
            end
        end
    end
    if self.RoundTimer:IsPastSimMS(100) and self.RoundTimer:IsPastSimMS(1000) == false then
        for actor in MovableMan.Actors do
            actor.AIMode = Actor.AIMODE_SENTRY;
        end
    end
    if self.ztimer:IsPastSimMS(self.ztime) and MovableMan:GetMOIDCount() <= self.maxmoids then
        local zed =  self:makeczombie()
        self.ztimer:Reset()
		self:teleporteffect(zed.Pos)
		zed:FlashWhite(2500)
        zed.Pos = Vector(20 + math.random(1000),self.hy - 10)
        zed.AIMode = Actor.AIMODE_BRAINHUNT
        MovableMan:AddActor(zed)
    end
    
    for actor in MovableMan.Actors do
        if ((actor:IsInGroup("Undead") and actor.Team == globalczteam and self.evacarea:IsInside(actor.Pos))) and self.CurrentFightStage ~= self.FightStage.RUN and MovableMan:GetMOIDCount() < 250  then
            self.CurrentFightStage = self.FightStage.RUN
            for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
                FrameMan:ClearScreenText(player)
                FrameMan:SetScreenText("You've unthawed from cryo. EVACUATE!", player, 0, 10000, false);
            end
            self.EscapeShip = CreateACDropShip("Drop Ship MK1");
            self.EscapeShip.Pos = Vector(self.RescueLZ:GetRandomPoint().X, 0);
            self.EscapeShip.Team = Activity.TEAM_1;
            self.EscapeShip:SetControllerMode(Controller.CIM_AI, -1);
            MovableMan:AddActor(self.EscapeShip)
            self.ztime = self.ztime * 0.5
            for ab in MovableMan.Actors do
                if ab.PresetName == "Gold Drill" then
                    ab.Health = 8
                    table.insert(cyborgzombielist,ab)
                end
            end
        end
        if not MovableMan:IsActor(self.playerbrain) and actor:HasObjectInGroup("Brains") then
            for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
                    self:SetPlayerBrain(actor, player)
            end
            self.playerbrain = actor
            actor.AIMode = Actor.AIMODE_RETURN
        end

        if actor:IsInGroup("Undead") and actor.Team == globalczteam  then
            if MovableMan:IsActor(self.playerbrain) and actor.AIMode ~= Actor.AIMODE_GOTO and actor.AIMode ~= Actor.AIMODE_BRAINHUNT then
                actor.AIMode = Actor.AIMODE_BRAINHUNT
            end
            if actor:GetController():IsState(Controller.MOVE_IDLE) then
                actor:GetController().SetState(Controller.MOVE_RIGHT, true)
            end
        end
    end
    if self.CurrentFightStage == self.FightStage.RUN then
        if MovableMan:IsActor(self.EscapeShip) then
            if self.EscapeShip.ID ~= self.playerbrain.ID then
                self:AddObjectivePoint("Escape on this!", self.EscapeShip.AboveHUDPos, Activity.TEAM_1, GameActivity.ARROWDOWN);
            end
        else
            self:AddObjectivePoint("Escape!", self.RescueLZ:GetCenterPoint() - Vector(0,32), Activity.TEAM_1, GameActivity.ARROWDOWN);
        end
    end
    self:YSortObjectivePoints();
else
    self.RoundTimer:Reset()
    self.ztimer:Reset()
end
end

function GreyGooDefense:CraftEnteredOrbit()
    --If a craft leaves with the brain robot...
    if self.OrbitedCraft:HasObject("Braincoat Heavy") then
	--Team 1 wins!
	self.WinnerTeam = Activity.TEAM_1;
	ActivityMan:EndActivity();
    for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
    FrameMan:ClearScreenText(player)
    FrameMan:SetScreenText("Good job surviving the attack! Don't worry about the nanites, we took them out with a radio command backdoor we found.", player, 0, 99999999, false);
    end
    for zed in MovableMan.Actors do
    if zed.Team == globalczteam then
    zed:GibThis()
    end
    end
    self.stopworking = true
end
end
