function Base:makelombie()
self.czlist = {"Light", "Regular", "Heavy", "Regen"}
self.zombieweaponlist = {"Zombie SMG", "Blunderpop", "Blunderbuss", "Zombie Shotgun", "Heavy Pistol"}
self.zombiebomblist = {"Blue Bomb", "Stone", "Stick Grenade", "Blue Bomb"}
local zombie1 = CreateAHuman(self.czlist[math.random(#self.czlist)].." Replicating Zombie")
zombie1:AddInventoryItem(CreateHDFirearm(self.zombieweaponlist[math.random(#self.zombieweaponlist)]))
zombie1:AddInventoryItem(CreateTDExplosive(self.zombiebomblist[math.random(#self.zombiebomblist)]))
zombie1:AddInventoryItem(CreateHDFirearm("Zombie Shovel"))
zombie1.Team = globalczteam
zombie1.AIMode = Actor.AIMODE_GOTO;
return zombie1
end
function Base:SpawnCoalition()
	local clone = CreateAHuman("EYES OF GOD", "CyborgZombies.rte")
	clone.Team = 1
	self.heavylist = {"Homing Missile Launcher", "Revolver Cannon", "Auto Cannon", "Spike Launcher", "Napalm Flamer", "Heavy Sniper Rifle", "Mauler Shotgun", "Gatling Gun"}
	--self.heavylist = {"Spike Launcher"}
	self.secondlist = {"Flamer","Assault Rifle", "Auto Shotgun", "Heavy Pistol"}
	self.explosivelist = {"Grenade","Cluster Grenade", "Incendiary Grenade"}
	local heavy = CreateHDFirearm("OP " .. self.heavylist[math.random(#self.heavylist)],"Cyborg Zombies.rte")
	local second = CreateHDFirearm(self.secondlist[math.random(#self.secondlist)],"Coalition.rte")
	local bomb = CreateTDExplosive(self.explosivelist[math.random(#self.explosivelist)],"Coalition.rte")
	local bombb = CreateTDExplosive(self.explosivelist[math.random(#self.explosivelist)],"Coalition.rte")
	heavy.Mass = 1
	second.Mass = 1
	bomb.Mass = 1
	bombb.Mass = 1
	if math.random(2) == 1 then
	clone:AddInventoryItem(CreateHDFirearm("Pulse Digger","Coalition.rte"))
	end
	clone:AddInventoryItem(heavy)
	clone:AddInventoryItem(bomb)
	clone:AddInventoryItem(bombb)
	if #self.ebrains > 0 then
		local curdist = 999999
		local dist = nil
		local targ = nil
		for num, brain in ipairs(self.ebrains) do
			dist = SceneMan:ShortestDistance(clone.Pos,brain.Pos,false).Magnitude
			if dist < curdist then
				targ = brain
				curdist = dist
			end
		end
		clone:AddAIMOWaypoint(targ)
	else
		clone.AIMode = Actor.AIMODE_SENTRY
	end
	clone.Pos = self:getsafelocation()
	MovableMan:AddActor(clone)
	clone:FlashWhite(2500)
	self:teleporteffect(clone.Pos)
end
function Base:teleporteffect(pos)
   if math.random(2) == 1 then
  	 local fxa = CreateAEmitter("Teleporter Effect A");
  	 fxa.Pos = pos;
  	 MovableMan:AddParticle(fxa);
   else
 	  local fxb = CreateAEmitter("Teleporter Effect B");
 	  fxb.Pos = pos;
 	  MovableMan:AddParticle(fxb);
   end
end

function Base:PauseActivity()
end
function Base:EndActivity()

end
function Base:getsafelocation()
local v = Vector(math.random(10,SceneMan.SceneDim.X-10), math.random(10,SceneMan.SceneDim.Y-10))
while SceneMan:GetTerrMatter(v.X,v.Y) ~= 0 or SceneMan:GetMOIDPixel(v.X,v.Y) ~= 255 do
v = Vector(math.random(10,SceneMan.SceneDim.X-10), math.random(10,SceneMan.SceneDim.Y-10))
end
v.Y = SceneMan:MovePointToGround(v,0,0).Y - 12
return v
end
function Base:StartActivity()
	SceneMan.Scene:GetArea("Kludge Zone") --limit selection
	self.maxmoids = 110 -- Reduce this if you have a slow computer, or if you are a coward.
	--self.ztime = (8000 * (self.Difficulty/100)) + 2000
	self.maxmoids = self.maxmoids + (110 * ((self.Difficulty)/100))
	self.etime = (2000 * ((120-self.Difficulty)/100)) + 500
	self.etime = self.etime / self.PlayerCount
	--self.ztime = self.ztime * self.PlayerCount
	globalczteam = 0
	self.bdeath = self:GetTeamDeathCount(globalczteam)
    self.RoundTimer = Timer();
   	--self.SpawnTimer = Timer();
	self.CoalTimer = Timer()
	self.DieTimer = Timer()
	self.run = true
	local brain = nil
   	for player = 0, self.PlayerCount - 1 do
		if not self:GetPlayerBrain(player) then
			brain = CreateActor("InvisiBrain","CyborgZombies.rte");
			brain.Team = 0;
			brain.Pos = Vector(10000,10000)--Vector(4530,545)
			MovableMan:AddActor(brain);
			self:SetPlayerBrain(brain, player);
			self:SetObservationTarget(brain.Pos, player)
			self:SwitchToActor(clone,player,0)
		end
	end
	self.ebrains = {}
	
		for player = 0, self.PlayerCount - 1 do
			self:SpawnZombie(player)
		end
	SceneMan:MakeAllUnseen(Vector(5, 5), Activity.TEAM_1)
end
function Base:UpdateActivity()
	self:SetTeamFunds(0 , 0); --comment out this, i dare you
   	self:ClearObjectivePoints();
	if #self.ebrains > 0 then
		for num, brain in ipairs(self.ebrains) do
			if not MovableMan:IsActor(brain) then
				table.remove(self.ebrains,num)
				break
			elseif self.Difficulty <= 50 then
				self:AddObjectivePoint("Destroy!", brain.AboveHUDPos, Activity.TEAM_1, GameActivity.ARROWDOWN);
			end
		end
	elseif not self.RoundTimer:IsPastSimMS(1000) then
		for actor in MovableMan.Actors do
			if actor.PresetName == "Brain Case" then
				table.insert(self.ebrains,actor)
			end
		end
	elseif self.run then
		self.run = false
			self.WinnerTeam = 0
			ActivityMan:EndActivity();
	end
	--if self.SpawnTimer:IsPastSimMS(self.ztime) and MovableMan:GetMOIDCount() < self.maxmoids then
	--	self.SpawnTimer:Reset()
	--	self:SpawnZombies()
	--else
	if self.CoalTimer:IsPastSimMS(self.etime) and  MovableMan:GetMOIDCount() < self.maxmoids then
		self.CoalTimer:Reset()
		self:SpawnCoalition()
	end
	local curdist = nil
	local dist = nil
	local targ = nil
	local die = not(cyborgzombielist ~= nil and #cyborgzombielist > math.floor(3 * self.Difficulty/100))
	for actor in MovableMan.Actors do 
		if (actor.Team == 0 and actor:IsInGroup("Undead")) then
			die = false
		end
		if actor.AIMode == Actor.AIMODE_SENTRY and #self.ebrains > 0 then
			curdist = 999999
			dist = nil
			targ = nil
			for num, brain in ipairs(self.ebrains) do
				dist = SceneMan:ShortestDistance(actor.Pos,brain.Pos,false).Magnitude
				if dist < curdist then
					targ = brain
					curdist = dist
				end
			end
			actor:AddAIMOWaypoint(targ)
			actor.AIMode = Actor.AIMODE_GOTO
		end
		if actor.Team == 1 then
			if actor.Health < 99 and  math.random(200) < math.ceil(self.Difficulty/10) then
				actor.Health = actor.Health + 1
			else
				actor:GetController():SetState(Controller.MOVE_FAST,true)
			end
		end
	end
	if self.Difficulty > 10 then
		for i = 1, MovableMan:GetMOIDCount() - 1 do
			mo = MovableMan:GetMOFromID(i)
			if mo.PresetName == "Zombie Shovel" then
				--ToAttachable(mo):GibThis()
				mo.Lifetime = 1
				--break
			end
		end
	end
	if die then
		if self.DieTimer:IsPastSimMS(1000) and self.run then
			self.run = false
				self.WinnerTeam = 1
				ActivityMan:EndActivity();
		end
	else
		self.DieTimer:Reset()
	end
	if not self.run then
	
    if self.WinnerTeam == 0 then
	
		for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player)
		FrameMan:SetScreenText("You have destroyed the enemy brains!", player, 1000, 99999999, false);
		end
	else
		for player = 0, self.PlayerCount - 1 do
		FrameMan:ClearScreenText(player)
		FrameMan:SetScreenText("How the heck did you run out of units, you disfunctional subroutine!?", player, 1000, 99999999, false);
		end
	end
	end
	self:YSortObjectivePoints();
end
function Base:SpawnZombie(player)
	local zombie = self:makelombie()
	--zombie.Pos = self:getsafelocation()
	zombie.Pos = Vector(4530,545)
	if #self.ebrains > 0 then
		local curdist = 999999
		local dist = nil
		local targ = nil
		for num, brain in ipairs(self.ebrains) do
			dist = SceneMan:ShortestDistance(zombie.Pos,brain.Pos,false).Magnitude
			if dist < curdist then
				targ = brain
				curdist = dist
			end
		end
		zombie:AddAIMOWaypoint(targ)
	else
		zombie.AIMode = Actor.AIMODE_SENTRY
	end
	zombie:FlashWhite(2500)
	self:teleporteffect(zombie.Pos)
	--zombie.Health = 0
	MovableMan:AddActor(zombie)
	self:SwitchToActor(zombie,player,0)
end
